// one line to give the program's name and an idea of what it does.
// Copyright (C) 2005  name of Borja Snchez Zamorano
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

using System;
using System.Drawing;
using System.Windows.Forms;

namespace MonoCalendar.MonthCalendar
{
	internal class Button : System.Windows.Forms.Control {
		Bitmap _offBmp = null;
		Pen pen1;
		int type;
		bool pressed = false;
		bool mouseIn = false;
		
		internal Button()
		{
			pen1 = new Pen(Color.Empty);
			this.SetStyle(ControlStyles.DoubleBuffer, true);
			this.SetStyle(ControlStyles.UserPaint, true);
			this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			this.SetStyle(ControlStyles.UserMouse, true);
			this.SetStyle(ControlStyles.ResizeRedraw, false);
			this.SetStyle(ControlStyles.Opaque, true);
			
			InitializeComponent();
			
			this.Resize += new System.EventHandler(this.ButtonResize);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.ButtonPaint);
		}
		
		#region Cdigo generado por el Diseador de Windows Forms
		
		void InitializeComponent() {
			// 
			// Button
			// 
			this.Name = "Button";
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.ButtonMouseUp);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.ButtonMouseMove);
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonMouseDown);
		}
		#endregion
		
		void ButtonResize(object sender, System.EventArgs e)
		{
			Repaint2();
		}
		
		void ButtonPaint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			e.Graphics.DrawImage(_offBmp, 0,0);
		}
		
		void Repaint2()
		{
			if ((this.ClientRectangle.Width<1) || (this.ClientRectangle.Height<1)) return;
			if ((_offBmp == null) || (_offBmp.Height != this.ClientRectangle.Height) || (_offBmp.Width != this.ClientRectangle.Width)) {
				if (_offBmp != null) _offBmp.Dispose();
				_offBmp = new Bitmap( this.ClientRectangle.Width, this.ClientRectangle.Height);
			}
			Graphics _g = Graphics.FromImage( _offBmp );
//			_g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
			
			_g.Clear(Color.White);
			PaintWidget(_g);
			_g.Dispose();
			Paint2();
		}
		
		void Paint2()
		{
			if ((_offBmp == null) || (_offBmp.Height != this.ClientRectangle.Height) || (_offBmp.Width != this.ClientRectangle.Width)) {
				Repaint2();
				return;
			}
			if ((this.ClientRectangle.Width<1) || (this.ClientRectangle.Height<1)) return;
			
			IntPtr hwnd = new IntPtr();
			hwnd = this.Handle;
			Graphics drawingSurface = Graphics.FromHwnd(hwnd);
			drawingSurface.DrawImage(_offBmp, 0, 0);
			drawingSurface.Dispose();
		}
		
		void DrawFillVGradient(Graphics g_, Rectangle rect1, Color color1, Color color2)
		{
			System.Int32 r, g, b;
			for (int i=0; i<rect1.Height; i++) {
				r = color2.R+((((rect1.Height-1)-i)*(color1.R-color2.R))/(rect1.Height-1));
				g = color2.G+((((rect1.Height-1)-i)*(color1.G-color2.G))/(rect1.Height-1));
				b = color2.B+((((rect1.Height-1)-i)*(color1.B-color2.B))/(rect1.Height-1));
				pen1.Color = Color.FromArgb(255, r, g, b);
				g_.DrawLine(pen1, rect1.Left, rect1.Top+i, rect1.Right-1, rect1.Top+i);
			}
		}
		
		void PaintWidget(Graphics g)
		{
			Rectangle rect1 = new Rectangle(0,0,this.ClientRectangle.Width,8);
			if ((mouseIn) && (pressed))
				DrawFillVGradient(g, rect1, Color.FromArgb(255, 208, 226, 245), Color.FromArgb(255, 104, 169, 234));
			else
				DrawFillVGradient(g, rect1, Color.FromArgb(255, 255, 255, 255), Color.FromArgb(255, 233, 233, 233));
			rect1 = new Rectangle(0,7,this.ClientRectangle.Width,9);
			if ((mouseIn) && (pressed))
				DrawFillVGradient(g, rect1, Color.FromArgb(255, 104, 169, 234), Color.FromArgb(255, 187, 252, 255));
			else
				DrawFillVGradient(g, rect1, Color.FromArgb(255, 233, 233, 233), Color.FromArgb(255, 255, 255, 255));
			
			if ((mouseIn) && (pressed))
				pen1.Color = Color.FromArgb(255, 102, 147, 192);
			else
				pen1.Color = Color.FromArgb(255, 178, 178, 178);
			g.DrawLine(pen1, this.ClientRectangle.Width-1, 0, this.ClientRectangle.Width-1, 15);
			g.DrawLine(pen1, 0, 16, this.ClientRectangle.Width, 16);
			
			pen1.Color = Color.FromArgb(255, 0, 0, 0);
			int x = this.ClientRectangle.Width/2;
			switch (type) {
				case 1:
					g.DrawLine(pen1, x, 6, x, 7);
					g.DrawLine(pen1, x-1, 7, x+1, 7);
					g.DrawLine(pen1, x-2, 8, x+2, 8);
					g.DrawLine(pen1, x-3, 9, x+3, 9);
					g.DrawLine(pen1, x-4, 10, x+4, 10);
					break;
				case 3:
					g.DrawLine(pen1, x, 10, x, 9);
					g.DrawLine(pen1, x-1, 9, x+1, 9);
					g.DrawLine(pen1, x-2, 8, x+2, 8);
					g.DrawLine(pen1, x-3, 7, x+3, 7);
					g.DrawLine(pen1, x-4, 6, x+4, 6);
					break;
				case 2:
					g.DrawLine(pen1, x, 5, x, 6);
					g.DrawLine(pen1, x-1, 6, x+1, 6);
					g.DrawLine(pen1, x-2, 7, x+2, 7);
					g.DrawLine(pen1, x-3, 8, x+3, 8);
					g.DrawLine(pen1, x-2, 9, x+2, 9);
					g.DrawLine(pen1, x-1, 10, x+1, 10);
					g.DrawLine(pen1, x, 11, x, 10);
					break;
			}
		}
		
		public int Type {
			get {
				return type;
			}
			set {
				type = value;
				Repaint2();
			}
		}
		
		void ButtonMouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == System.Windows.Forms.MouseButtons.Left) {
				pressed = true;
				mouseIn = true;
				Repaint2();
			}
		}
		
		void ButtonMouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == System.Windows.Forms.MouseButtons.Left) {
				if ((pressed) && (mouseIn))
					OnClick();
				pressed = false;
				Repaint2();
			}
		}
		
		void ButtonMouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (pressed) {
				if ((e.X<0) || (e.Y<0) || (e.Y > this.ClientRectangle.Height) || (e.X > this.ClientRectangle.Width)) {
					if (mouseIn) {
						mouseIn = false;
						Repaint2();
					}
				} else {
					if (!mouseIn) {
						mouseIn = true;
						Repaint2();
					}
				}
			}
		}
		
		protected virtual void OnClick()
		{
			if (Click != null) Click(this, System.EventArgs.Empty);
		}
		
		new public event EventHandler Click;
	}
}
